// ==============================================================
// RTL generated by Vivado(TM) HLS - High-Level Synthesis from C, C++ and SystemC
// Version: 2014.1
// Copyright (C) 2014 Xilinx Inc. All rights reserved.
// 
// ===========================================================

`timescale 1 ns / 1 ps 

(* CORE_GENERATION_INFO="limiter_samples,hls_ip_2014_1,{HLS_INPUT_TYPE=cxx,HLS_INPUT_FLOAT=0,HLS_INPUT_FIXED=1,HLS_INPUT_PART=xc6slx9tqg144-2,HLS_INPUT_CLOCK=10.000000,HLS_INPUT_ARCH=others,HLS_SYN_CLOCK=5.103938,HLS_SYN_LAT=0,HLS_SYN_TPT=none,HLS_SYN_MEM=0,HLS_SYN_DSP=0,HLS_SYN_FF=0,HLS_SYN_LUT=0}" *)

module limiter17 (
        ap_clk,
        ap_rst_n,
        input_data,
        input_empty_n,
        input_read,
        output_data,
        output_full_n,
        output_write
);

input   ap_clk;
input   ap_rst_n;
input  [23:0] input_data;
input   input_empty_n;
output   input_read;
output  [23:0] output_data;
input   output_full_n;
output   output_write;

reg input_read;
reg output_write;
reg   [16:0] output_buff;
reg   [0:0] state_reg = 1'b0;
reg    flow_is_busy;
wire   [0:0] flag_too_high;
wire   [16:0] input_data_or_max;
//wire   [1:0] msb_2bits;
wire   [0:0] flag_too_low;
reg   [0:0] state_new;




/// the current state (state_reg) of the state machine. ///
always @ (posedge ap_clk)
begin : ap_ret_state_reg
    if (ap_rst_n == 1'b0) begin
        state_reg <= 1'b0;
    end else begin
        state_reg <= state_new;
    end
end

/// input_read assign process. ///
always @ (state_reg or flow_is_busy)
begin
    if (((1'b0 == state_reg) & ~flow_is_busy)) begin
        input_read = 1'b1;
    end else begin
        input_read = 1'b0;
    end
end

/// output_write assign process. ///
always @ (state_reg or flow_is_busy)
begin
    if (((1'b0 == state_reg) & ~flow_is_busy)) begin
        output_write = 1'b1;
    end else begin
        output_write = 1'b0;
    end
end

/// output_buff assign process. ///
always @ (state_reg or flag_too_high or input_data_or_max)
begin
    if ((1'b0 == state_reg)) begin
        if ((flag_too_high == 1'b0)) begin
            output_buff = input_data_or_max;
        end else if (~(flag_too_high == 1'b0)) begin
//            output_buff = 17'b111111111111111;
            output_buff = 17'd49152;
				//output_buff = 17'd32767;
        end else begin
            output_buff = 'bx;
        end
    end else begin
        output_buff = 'bx;
    end
end
always @ (state_reg or flow_is_busy)
begin
    case (state_reg)
        1'b0 : 
            state_new = 1'b0;
        default : 
            state_new = 'bx;
    endcase
end

/// flow_is_busy assign process. ///
always @ (input_empty_n or output_full_n)
begin
    flow_is_busy = ((input_empty_n == 1'b0) | (output_full_n == 1'b0));
end
//assign flag_too_high = (msb_2bits == 2'b1 ? 1'b1: 1'b0);

//assign output_data = {output_buff[16], output_buff[16], output_buff[16], output_buff[16],
//                      output_buff[16], output_buff[16], output_buff[16], output_buff[16:0]};

assign output_data = {7'bx, output_buff[16:0]};
							 
//assign input_data_or_max = ((flag_too_low) ? 17'b11000000000000000 : input_data[16:0]);

assign input_data_or_max = ((flag_too_low) ? $signed(-17'd49152) : input_data[16:0]);
assign flag_too_high = ($signed(input_data[16:0]) > $signed(17'd49152) ? 1'b1: 1'b0);
assign flag_too_low = ($signed(input_data[16:0]) < $signed(-17'd49152) ? 1'b1: 1'b0);

//assign input_data_or_max = ((flag_too_low) ? $signed(-17'd32768) : input_data[16:0]);
//assign flag_too_high = ($signed(input_data[16:0]) > $signed(17'd32767) ? 1'b1: 1'b0);
//assign flag_too_low = ($signed(input_data[16:0]) < $signed(-17'd32768) ? 1'b1: 1'b0);

//assign msb_2bits = {{input_data[16 : 15]}};


endmodule //limiter17

